#!/usr/bin/perl
$| = 1;

use strict;
use LWP::UserAgent;
#use LWP::Simple;
use HTML::TagParser;
use YAML::Syck;

# UserAgent
my $ua = LWP::UserAgent->new( (requests_redirectable => []));
$ua->max_redirect(0);

# const and init
my $config = LoadFile('./config.yaml');

# load yaml
my $result = {};

my $file = shift;
if($file ne ''){
    $result = LoadFile($file);
    $result->{'offset'} = $result->{'bookmarker'};
    $result->{'bookmarker'} = 0;
}else{
    $result->{'users'} = {};
    $result->{'bookmarker'} = 0;
    $result->{'offset'} = 0;
    $result->{'todoline'} = [];
    foreach my $user (@{$config->{first_user}}){
	push_first_user($user);
    }
}

# add list
## this routine is obsolute
if(0){
while(my $line = <STDIN>){
    chomp $line;
    my ($id) = ($line =~ /([-_a-zA-Z0-9]+)/);
    next if($id eq '');
    unless(defined $result->{'users'}->{$id}){
	push_first_user($id);
#	print $id,"\n";
    }
}
}

# subroutine
sub push_first_user($){
    my ($user) = @_;
    my %item;
    $item{'fav_list'} = [];
    $item{'faved_list'} = [];
    $item{'fav_count'} = 0;
    $item{'faved_count'} = 0;
    $result->{'users'}->{$user}= \%item ;
    push(@{$result->{'todoline'}},$user);
}

sub get_url($){
    my ($url) = @_;
    my $err_count = 0;
    my $response;;
#    my $html;
    while((not $response = $ua->get($url)) &&
#    while ((not $html = get($url)) &&
	   $err_count <5){
#	print $err_count;
	$err_count++;}
    if($response->code != 200){
	return $response->code;
    }else{
	return $response->content;
    }
}

# scan user
foreach my $user (@{$result->{todoline}}){
    # count bookmarker
    $result->{'bookmarker'}++;
#    print "\x0d",$result->{'bookmarker'},": ",$user,"             ";
    next if($result->{'bookmarker'} <= $result->{'offset'});
    last if($result->{'bookmarker'} > $config->{'max_count'});

	# my favorite list
	my $bookmark = get_url($config->{base_url}.$user.$config->{dir});

	if($bookmark =~ /^[0-9]+$/){
		$result->{'users'}->{$user}->{'response'} = $bookmark;
	}else{
		my $html = HTML::TagParser->new($bookmark);
		if(my @favorites = $html->getElementsByClassName("profile-icon")){
			foreach my $favorite (@favorites){
				my $text = $favorite->getAttribute("href");
#				print $text;
				$text =~ s{/}{}g;
				next if($text eq $user);
				unless(defined $result->{'users'}->{$text}){
					push_first_user($text);
					print $text,"\n";
				}
				push(@{$result->{'users'}->{$user}->{fav_list}},$text);
			}
##			my $favorite;
##			foreach my $div (@favorites){
##				$favorite .= $div->innerText."\n";
##			}
##			my @texts = split(/[\s\n]+/,$favorite);
		}else{
#			$result->{'nouse_favorite'}++;
		}
		undef $html;
    }
    undef $bookmark;

	# my followers list
	my $bookmark = get_url($config->{base_url}.$user."/follower");
	if($bookmark =~ /^[0-9]+$/){
		$result->{'users'}->{$user}->{'response'} = $bookmark;
	}else{
		my $html = HTML::TagParser->new($bookmark);
		if(my @favorites = $html->getElementsByClassName("username")){
			foreach my $favorite (@favorites){
				my $text = $favorite->innerText;
				push(@{$result->{'users'}->{$user}->{faved_list}},$text);
				unless(defined $result->{'users'}->{$text}){
					push_first_user($text);
#					print $text,"\n";
				}
			}
		}
		undef $html;
	}
	undef $bookmark;

    # my favorited number
	my $bookmark = get_url($config->{base_url}.$user."/");
	if($bookmark =~ /^[0-9]+$/){
#	print "$user: $bookmark (fav)\n";
		$result->{'users'}->{$user}->{'response'} = $bookmark;
		$result->{'retired'}++;
		next;
	}else{
		my $html = HTML::TagParser->new($bookmark);
		if(my @links = $html->getElementsByTagName("a")){
			foreach my $link (@links){
				if($link->getAttribute("href") eq "/".$user."/favorite"){
					my $number = $link->innerText;
					if($number =~ /^([0-9,]+)$/){
						my $num = $1;
						$num =~ s/,//g;
						$result->{'overall_favorites'}+= $num;
						$result->{'users'}->{$user}->{'fav_count'} = $num;
						if($num == 0){
							$result->{'nouse_favorite'}++;
						}
					}
				}
				if($link->getAttribute("href") eq "/".$user."/follower"){
					my $number = $link->innerText;
					if($number =~ /^([0-9,]+)$/){
						my $num = $1;
						$num =~ s/,//g;
						$result->{'users'}->{$user}->{'faved_count'} = $num;
					}
				}
			}
	    #	print $result->{faved_count}->{$user},"\t";
		}
		if(my $favorited = $html->getElementsByClassName("hatena-module-body")){
			my $text = $favorited->innerText;
			if($text =~ /ブックマーク数\s*([0-9,]+)/){
				my $number = $1;
				$number =~ s/,//g;
				$result->{'users'}->{$user}->{bookmark_count} = $number+0;
			}
		}
		undef $html;
	}
	undef $bookmark;
	# auto save
	if($result->{'bookmarker'} % $config->{skips} == 0){
	DumpFile('result.yaml', $result);
	}
}
#print "\n";

# result (user)
#foreach my $user (sort {$result->{favorited_count}->{$b} <=> $result->{favorited_count}->{$a} || $a cmp $b} keys %{$result->{favorited_count}}){
#    print $user,"\t",$result->{favorited_count}->{$user},"\t",$result->{users_count}->{$user},"\t";
#    print join(",",(sort @{$result->{favorite_users}->{$user}}));
#    print "\n";
#}

# result (outline)
print "bookmarkers: ", scalar(@{$result->{'todoline'}}) ,"\n";
print "favorited bookmarkers: ", $result->{'bookmarker'} ,"\n";
print "retired bookmarkers: ", $result->{'retired'} ,"\n";
print "no use favorite bookmarkers: ", $result->{'nouse_favorite'} , "\n";
print "overall favorites: ",$result->{'overall_favorites'}, "\n";

# save when all scan finished
if($result->{'bookmarker'} == scalar(@{$result->{'todoline'}})){
    DumpFile('result.yaml', $result);
}
